#include <stdio.h>
const int PMAX=400;
const int N=200;
int res[N][2], p[N][2], n, a;
bool better(int x)
{
    return res[x][0]+res[x][1]>res[0][0]+res[0][1];
}
int main()
{
    freopen("juggling.in", "r", stdin);
    freopen("juggling.out", "w", stdout);
    scanf("%d%d", &n, &a); a--;
    //построение 0-деления в каждом туре
    for(int j=0; j<2; ++j)
        for(int i=0; i<n; ++i)
        {
            scanf("%d", &p[i][j]);
            p[i][j]--;
            res[p[i][j]][j]=n-i;
        }
    //вычисление текущего места
    int cp=0;
    for(int i=0; i<n; ++i)
        if(better(i))
            cp++;
    if(cp<a)
    {
        //мы слишком высоко, передвигаем вверх остальных
        int s=0, t=0, pts_0=PMAX, pts_1=PMAX;
        while((cp<a)&&((p[s][0]!=0)||(p[t][1]!=0)))
        {
            if(p[s][0]!=0)
            {
                if(!better(p[s][0])) cp++;
                res[p[s][0]][0]=pts_0, pts_0--;
                s++;
            }
            else
            {
                if(!better(p[t][1])) cp++;
                res[p[t][1]][1]=pts_1, pts_1--;
                t++;
            }
        }
    }
    else
    if(cp>a)
    {
        //переход к n-делению в каждом туре
        for(int j=0; j<2; ++j)
        {
            int pts=PMAX;
            for(int i=0; i<n; ++i)
            {
                res[p[i][j]][j]=pts, pts--;
            }
        }
        int s=n-1, t=n-1, pts_0=1, pts_1=1;
        while((cp>a)&&((p[s][0]!=0) || (p[t][1]!=0)))
        {
            if(p[s][0]!=0)
            {
                if(better(p[s][0])) cp--;
                res[p[s][0]][0]=pts_0, pts_0++;
                s--;
            }
            else
            {
                if(better(p[t][1])) cp--;
                res[p[t][1]][1]=pts_1, pts_1++;
                t--;
            }
        }
    }
    if(cp==a)
    {
        printf("Possible\n");
        for(int j=0; j<2; ++j)
        {
            for(int i=0; i<n; ++i)
                printf("%d ", res[p[i][j]][j]);
            printf("\n");
        }
    } else printf("Impossible");
    return 0;
}
